关闭

Android5.0以上版本ActiveAndroid报ClassNotFoundException错误

标签: androidappjava应用手机
1648人阅读 评论(1) 收藏 举报
分类:

近日将正在开发的app运行到android lollipop系统上却出现的闪退,经过查找发现是ActiveAndroid在5.0上的兼容性问题。

通常我们初始化ActiveAndroid的时候,是通过在自定义的Application中的onCreate()方法中调用

ActiveAndroid.initialize(this);
或者是自定义的Application直接继承com.activeandroid.app.Application

如上代码在5.0以下的系统不会有问题,以上就会直接导致app在应用的入口处就直接crash。

我们在5.0及以上版本需要换一种声明方式,如下:

public class MyApplication extends Application {
	@Override
	public void onCreate() {
	    super.onCreate();

	    initializeDB();
	}

	protected void initializeDB() {
	    Configuration.Builder configurationBuilder = new Configuration.Builder(this);
	    configurationBuilder.addModelClasses(Test.class);
	    ActiveAndroid.initialize(configurationBuilder.create());
	}
}
关于上述代码做几点说明:

1. MyApplication继承的是android原生的Application,必须继承原生的;

2. 很重要!Test.class为应用用到的ActiveAndroid的数据库模型,所有的模型必须在此声明;

3. 如果Configuration类找不到,说明你的ActiveAndroid的jar包版本太低的(需要3.1)


最后再说下,如果碰到了棘手的问题,百度无法解决的时候,多去StackOverflow搜索下,会有很多的收获。

本文参考自:http://stackoverflow.com/questions/23907037/how-to-disable-scanning-for-model-in-activeandroid/

ActiveAndroid官方网址:http://www.activeandroid.com


附上jar包下载地址:http://download.csdn.net/detail/njweiyukun/9278387


2
0

查看评论
* 以上用户言论只代表其个人观点,不代表CSDN网站的观点或立场
    个人资料
    • 访问:77107次
    • 积分:927
    • 等级:
    • 排名:千里之外
    • 原创:28篇
    • 转载:9篇
    • 译文:0篇
    • 评论:101条
    文章分类
    最新评论